#ifndef DEBUGGING_REGEXIS024_PRETTYPRINT_UTIL_H
#define DEBUGGING_REGEXIS024_PRETTYPRINT_UTIL_H

/* Used for debug. Do not give to user */

#include <vector>
#include <string>

typedef std::vector<std::string> lines;

struct TreeWithStringsNode {
    std::string val;
    std::vector<TreeWithStringsNode> childeren;

    explicit TreeWithStringsNode(const std::string &val);
    TreeWithStringsNode() = default;

    void toLines(lines& out) const;
};

lines wrapWithBox(const lines& in);

void printLines(const lines& in);

#endif
